%define expat_version           1.95.5
%define glib2_version           2.2.0
%define dbus_version            0.20

%define lib_name %mklibname %{name} 0
%define lib_major 0

Summary: Hardware Abstraction Layer
Name: hal
Version: 0.4.8
Release: 15.1.20060mdk
URL: http://www.freedesktop.org/Software/hal
Source0: http://freedesktop.org/~david/dist/%{name}-%{version}.tar.bz2
Source1: %{name}-pt_BR.po.bz2
# (fc) 0.2.6-1mdk fix lock dir location and fix failed start
Patch0: hal-0.2.98-lockdir.patch.bz2
Patch2: hal-0.2.90-linux-headers.patch.bz2
# (fc) 0.2.97-3mdk fix start order (Mdk bug #11404)
Patch3: hal-0.2.97-order.patch.bz2
# (fc) 0.4.7-4mdk default settings for mountpoints
Patch5: hal-0.4.7-defaults.patch.bz2
# (fc) 0.4.7-5mdk detect supermount entry in fstab (Mdk bug #13832)
Patch6: hal-0.4.7-supermount.patch.bz2
# (gb) 0.4.7-7mdk 64-bit fixes
Patch8: hal-0.4.7-64bit-fixes.patch.bz2
# (fc) 0.4.7-8mdk fix translation
Patch10: hal-0.4.8-fixpo.patch.bz2
# (fc) 0.4.7-9mdk fix media check on usb memory keys (Mdk bug #15070)
Patch11: hal-0.4.7-usbmediacheck.patch.bz2
# (fc) 0.4.7-6mdk fix double volume entries (Mdk bug #15224) (Andrej)
Patch12: hal-0.4.7-doublevolume.patch.bz2
# (fc) 0.4.8-3mdk improve DVDRAM and DVD-ROM DL detection (CVS)
Patch13: hal-0.4.8-detectcd.patch.bz2
# (fc) 0.4.8-5mdk fix floppy detection (Mdk bug #16759)
Patch14: hal-0.4.8-floppy.patch.bz2
# (pt) 0.4.8-10mdk fix breaking when last 2 numbers are not there
Patch15: hal-0.4.8-eol.patch.bz2
# pt_BR addition
Patch16: hal-0.4.8-pt_BR-configure.patch.bz2
License: AFL/GPL
Group: System/Libraries
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot
Requires(pre): rpm-helper
Requires(preun): rpm-helper
Requires(post): rpm-helper
Requires(postun): rpm-helper
BuildRequires: expat-devel >= %{expat_version}
BuildRequires: glib2-devel >= %{glib2_version}
BuildRequires: dbus-devel    >= %{dbus_version}
BuildRequires: libcap-devel
BuildRequires: libselinux-devel
BuildRequires: python python-devel
BuildRequires: pciutils
BuildRequires: popt-devel
BuildRequires: docbook-utils
BuildRequires: automake1.9
BuildRequires: autoconf2.5 >= 2.58
BuildRequires: glibc-static-devel
BuildRequires: perl-XML-Parser
BuildRequires: ImageMagick
BuildRequires: docbook-dtd412-xml
BuildRequires: doxygen
BuildRequires: intltool
Requires: dbus >= %{dbus_version}
#needed to get pci.ids
Requires: pciutils 
#needed to get usb.ids
Requires: usbutils

%description

HAL is daemon for collection and maintaining information from several
sources about the hardware on the system. It provides a live device
list through D-BUS.


%package gnome
Summary: GNOME based device manager for HAL
Group: Graphical desktop/GNOME
Requires: dbus-python >= %{dbus_version}
Requires: pygtk2.0-libglade >= 2.0.0
Requires: gnome-python >= 2.0.0
Requires: gnome-python-gnomevfs >= 2.0.0

%description gnome
GNOME program for displaying the devices detected by HAL

%package -n %{lib_name}
Summary: Shared library for using HAL
Group: System/Libraries
Requires: %name >= %{version}-%{release}

%description -n %{lib_name}
HAL shared library.

%package -n %{lib_name}-devel
Summary: Libraries and headers for HAL
Group: Development/C
Requires: %{name} = %{version}
Requires: %{lib_name} = %{version}
Provides: %{name}-devel = %{version}-%{release}
Provides: lib%{name}-devel = %{version}-%{release}
#gw got this from the pkgconfig file:
Requires: dbus-devel >= %{dbus_version}

%description -n %{lib_name}-devel

Headers and static libraries for HAL.


%prep
%setup -q
%patch0 -p1 -b .lockdir
%patch2 -p1 -b .header
%patch3 -p1 -b .order
%patch5 -p1 -b .defaults
%patch6 -p1 -b .supermount
%patch8 -p1 -b .64bit-fixes
%patch10 -p1 -b .fixpo
%patch11 -p1 -b .usbmediacheck
%patch12 -p1 -b .doublevolume
%patch13 -p1 -b .detectcd
%patch14 -p1 -b .floppy
%patch15 -p0 -b .eol
%patch16 -p1 -b .pt_BR

# Copy Missing pot files
( cd po
bzcat %{SOURCE1} > pt_BR.po
)

#fix build
aclocal-1.9
automake-1.9

autoconf

%build

%configure2_5x --with-pid-file=%{_var}/run/haldaemon.pid --enable-fstab-sync --enable-hotplug-map  --enable-pcmcia-support --enable-sysfs-carrier

%make

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall_std

%find_lang %{name}

cat << EOF > $RPM_BUILD_ROOT%{_datadir}/hal/fdi/30osvendor/usb-disable-mediacheck.fdi
<?xml version="1.0" encoding="ISO-8859-1"?> <!-- -*- SGML -*- -->

<deviceinfo version="0.2">
  <device>
    <match key="info.bus" string="usb">
      <match key="usb.vendor_id" int="0x67b">
        <match key="usb.product_id" int="0x2317">
          <merge key="storage.media_detection_enabled" type="bool">false</merge>
        </match>
      </match>
      <match key="usb.vendor_id" int="0x054c">
        <match key="usb.product_id" int="0x008b">
          <merge key="storage.media_detection_enabled" type="bool">false</merge>
        </match>
      </match>
    </match>
  </device>
</deviceinfo>
EOF

install -d -m 755 $RPM_BUILD_ROOT%{_menudir}
cat >$RPM_BUILD_ROOT%{_menudir}/hal-gnome <<EOF
?package(hal-gnome): \
	command="%{_bindir}/hal-device-manager" \
	needs="X11" \
	section="Configuration/Hardware" \
	icon="hal-device-manager.png" \
	title="Device Manager" \
	longtitle="Shows information about hardware on your system" \
	startup_notify="true"
EOF
mkdir -p %buildroot{%_liconsdir,%_miconsdir,%_iconsdir}
convert -scale 48x48 tools/device-manager/fdo-logo.png %buildroot%_liconsdir/hal-device-manager.png
convert -scale 32x32 tools/device-manager/fdo-logo.png %buildroot%_iconsdir/hal-device-manager.png
convert -scale 16x16 tools/device-manager/fdo-logo.png %buildroot%_miconsdir/hal-device-manager.png

# remove sony DSC file, it confuses HAL and gvm to much
rm -f $RPM_BUILD_ROOT%{_datadir}/hal/fdi/20freedesktop/sony_dsc.fdi

# (blino) use udev rules to replace deprecated dev.d and hotplug.d links
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/dev.d/default/10-hal.dev
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/hotplug.d/default/20-hal.hotplug
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/udev/rules.d
cat > $RPM_BUILD_ROOT%{_sysconfdir}/udev/rules.d/60-hal.rules <<EOF
ENV{UDEVD_EVENT}=="1", RUN+="%{_libdir}/hal.hotplug"
SUBSYSTEM=="block|class|net", RUN+="%{_libdir}/hal.dev"
EOF

%clean
rm -rf %{buildroot}

%triggerpostun -- hal < 0.2.97-3mdk
/sbin/chkconfig --del haldaemon
/sbin/chkconfig --add haldaemon


%pre
%_pre_useradd haldaemon / /sbin/nologin
%_pre_groupadd daemon hamdaemon

%post -n %{lib_name} -p /sbin/ldconfig

%post
%_post_service haldaemon

%preun
%_preun_service haldaemon

%postun -n %{lib_name} -p /sbin/ldconfig

%postun
%_post_service haldaemon

%post gnome
%update_menus

%postun gnome
%clean_menus

%files -f %{name}.lang
%defattr(-,root,root)
%doc COPYING ChangeLog NEWS
%doc doc/conf/*.fdi
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/hal.conf
%config(noreplace) %{_sysconfdir}/rc.d/init.d/*
%config(noreplace) %{_sysconfdir}/udev/rules.d/60-hal.rules
%config(noreplace) %{_sysconfdir}/hal/device.d/40-hal-hotplug-map.hal
%config(noreplace) %{_sysconfdir}/hal/device.d/50-fstab-sync.hal
%config(noreplace) %{_sysconfdir}/hal/hald.conf
%dir %{_sysconfdir}/hal/
%dir %{_sysconfdir}/hal/device.d
%{_sbindir}/hald
%{_sbindir}/fstab-sync
%{_bindir}/lshal
%{_bindir}/hal-get-property
%{_bindir}/hal-set-property
%_mandir/man8/fstab-sync.8*

%{_libexecdir}/hal.hotplug
%{_libexecdir}/hal.dev
%{_libexecdir}/hal-hotplug-map

%dir %{_datadir}/hal
%{_datadir}/hal/fdi

%files -n %{lib_name}
%defattr(-,root,root)
%{_libdir}/*hal*.so.*

%files -n %{lib_name}-devel
%defattr(-,root,root)
%doc doc/api/html/ doc/TODO doc/spec/*.png doc/spec/*.html
%{_libdir}/lib*.a
%{_libdir}/lib*.la
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*
%{_includedir}/*


%files gnome
%defattr(-,root,root)
%{_datadir}/hal/device-manager
%{_bindir}/hal-device-manager
%_menudir/hal-gnome
%_liconsdir/hal-device-manager.png
%_iconsdir/hal-device-manager.png
%_miconsdir/hal-device-manager.png

%changelog
* Wed Jan 04 2006 Stew Benedict <sbenedict@mandriva.com> 0.4.8-15.1.20060mdk
- rebuild of Frederic's update for updates

* Tue Jan 03 2006 Frederic Crozat <fcrozat@mandriva.com> 0.4.8-15mdk
- Update patch5 to support integrated card readers seen as scsi removable disk

* Fri Sep 16 2005 Helio Chissini de Castro <helio@mandriva.org> 0.4.8-14mdk
- Added non existant pt_BR translation

* Thu Sep 15 2005 Götz Waschk <waschk@mandriva.org> 0.4.8-13mdk
- fix deps for the pre and post scripts

* Tue Sep 13 2005 Olivier Blin <oblin@mandriva.com> 0.4.8-12mdk
- fix hal.dev udev rule so that it is run for the restricted set of
  subsystems that get a DEVNAME (block, class and net)

* Mon Sep 12 2005 Frederic Crozat <fcrozat@mandriva.com> 0.4.8-11mdk 
- don't run hal.dev when node are not creating (stop filling syslog with
  DEVNAME not set error message) (blino)
- fix description (daouda)

* Tue Sep 06 2005 Pascal Terjan <pterjan@mandriva.org> 0.4.8-10mdk
- don't fail when otional fields 5 and 6 are not present

* Mon Aug  8 2005 Olivier Blin <oblin@mandriva.com> 0.4.8-9mdk
- use udev rules to replace deprecated dev.d and hotplug.d links

* Fri Jul 29 2005 Frederic Crozat <fcrozat@mandriva.com> 0.4.8-8mdk 
- Add missing dependency in hal-gnome

* Thu Jul 28 2005 Frederic Crozat <fcrozat@mandriva.com> 0.4.8-7mdk 
- Update patch5, don't enable sync anymore, it doesn't do what we 
  want (Mdk bug #16872)

* Tue Jul 19 2005 Frederic Crozat <fcrozat@mandriva.com> 0.4.8-6mdk 
- Patch12 is back, new version from Andrej, fix Mdk big #15224 without
  regression on USB HD with 2 partitions

* Tue Jul 19 2005 Frederic Crozat <fcrozat@mandriva.com> 0.4.8-5mdk 
- Patch14 : fix floppy detection with kernel >= 2.6.12 (Mdk bug #16759)

* Mon Jul 11 2005 Gtz Waschk <waschk@mandriva.org> 0.4.8-4mdk
- replace prereq
- drop patch 12, it breaks USB HDs with 2 partitions.

* Fri Jul 08 2005 Frederic Crozat <fcrozat@mandriva.com> 0.4.8-3mdk 
- Patch12 (Andrej): fix double volume entries
- Patch13 (CVS): improve DVDRAM and DVDROM-DL detection

* Fri May 27 2005 Christiaan Welvaart <cjw@daneel.dyndns.org> 0.4.8-2mdk
- add BuildRequires: automake1.9 intltool

* Fri May 20 2005 Frederic Crozat <fcrozat@mandriva.com> 0.4.8-1mdk 
- Release 0.4.8
- remove patches 4, 9 (merged upstream), 7 (no longer needed)
- update patch10 (partially merged)

* Wed Apr 06 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.7-11mdk 
- Update patch1& to only disable media check for blaclisted devices

* Mon Apr 04 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.7-10mdk 
- Remove Sony DSC fdi file, it confuses HAL and g-v-m

* Thu Mar 31 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.7-9mdk 
- Patch11: disable media check after first check for USB memory key (Mdk bug #15070)
- Update patch5 to enable back media check 
- Patch12 (CVS): fix huge memleak

* Thu Mar 17 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.7-8mdk 
- Patch9 (CVS): fix zip naming
- Patch10 (CVS): fix translation

* Tue Mar  8 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.4.7-7mdk
- libtool & 64-bit fixes

* Thu Feb 24 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.7-6mdk 
- Update patch0 to better detect when startup failed (Mdk bug #13949)

* Mon Feb 21 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.7-5mdk 
- Patch6: detect supermount entry in fstab (Mdk bug #13832)

* Tue Feb 15 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.7-4mdk 
- Patch4 (Fedora): fix net link status detection
- Patch5: change defaults settings (based on patch from Fabrice Facorat)
- Requires usbutils to get usb.ids
- Enable sysfs carrier and pcmcia support

* Fri Feb 11 2005 Christiaan Welvaart <cjw@daneel.dyndns.org> 0.4.7-3mdk
- add BuildRequires: docbook-dtd412-xml doxygen

* Sat Feb  5 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.4.7-2mdk
- fix buildrequires

* Thu Jan 27 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.4.7-1mdk
- add more docs
- New release 0.4.7

* Thu Jan 20 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.4.5-1mdk
- update file list
- New release 0.4.5

* Fri Dec 10 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.2-1mdk
- New release 0.4.2

* Thu Dec 09 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.1-3mdk
- library package now requires main package

* Thu Nov 11 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.4.1-2mdk
- build with libselinux

* Wed Nov 10 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.4.1-1mdk
- drop merged patches 4,5
- New release 0.4.1

* Fri Nov  5 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.4.0-2mdk
- buildrequires

* Mon Oct 18 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.4.0-1mdk
- Release 0.4.0
- Patch4 (Fedora): fix NON_BLOCK usage
- Patch5 (Fedora): don't use UUID as mount point name

* Fri Sep 24 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.98-2mdk
- fix buildrequires

* Thu Sep 23 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.98-1mdk
- adapt file list
- drop merged patch 1
- rediff patch 0
- New release 0.2.98

* Mon Sep 13 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.2.97-3mdk
- Patch3 : Start haldaemon earlier in boot process (Mdk bug #11404)

* Mon Sep 13 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.97-2mdk
- fix buildrequires

* Fri Sep 10 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.2.97-1mdk
- Release 0.2.97
- Remove patch 3 (merged upstream)

* Fri Jul 16 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.94-1mdk
- update file list
- fix build
- New release 0.2.94

* Fri Jul  9 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.93-1mdk
- add configuration file
- fix URL
- reenable libtooize
- patch2 to fix build
- new version

* Thu Apr 22 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.90-3mdk
- remove device manager from main package
- add menu entry for the hal-device-manager

* Wed Apr 21 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.90-2mdk
- fix buildrequires

* Tue Apr 20 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.2.90-1mdk
- Release 0.2.90 (grabbed from project Utopia)
- Requires pciutils to get pci.ids file 

* Sat Jan 31 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.6-5mdk
- fix buildrequires

* Sat Jan 31 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.6-4mdk
- fix devel requires

* Fri Jan 30 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.2.6-3mdk
- fix buildrequires

* Thu Jan 29 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.2.6-2mdk
- Fix hal-gnome dependency (houpla)

* Mon Jan 26 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.2.6-1mdk
- First Mandrake package  (based on David Zeuthen package)
- Patch0 : fix lock directory location

